package ch.hevs.isi.core;

import java.util.HashMap;
import java.util.Map;

public abstract class DataPoint{
    private static Map<String, DataPoint> dataPointMap = new HashMap<>();
    private String label;
    private boolean isOutput;
    protected DataPoint(String label, boolean isOutput){
        this.label = label;
        this.isOutput = isOutput;
    }
    protected void update(boolean isNewValue){

        if(isNewValue){
            dataPointMap.put(this.label, this);
        } else {
            dataPointMap.replace(this.label, this);
        }

        // Update every connector
        DataPointListener.listeners.forEach(listener -> listener.onNewValue(this));
    }
    public static DataPoint getDataPointFromLabel(String label){
        if( !dataPointMap.containsKey(label) ){
            return null;
        } else {
            return dataPointMap.get(label);
        }

    }
    /**
     * Just get the label of this DataPoint
     * @return the label in a string
     */
    public String getLabel(){
        return this.label;
    }
    public boolean isOutput(){
        return this.isOutput;
    }

}

